%MACRO CUSP2(A1CUSP2=,
	A2CUSP2=,
	A3CUSP2=);
%LET D1=0.10;

OPTIONS NODATE NONUMBER;


data _null_;
set mcusp2;
CALL SYMPUT("LOC",PUT(LLOC,4.0));
CALL SYMPUT("NUM",PUT(LNUM,4.0));
CALL SYMPUT("T",PUT(LT,5.1));
CALL SYMPUT("LBOUND",PUT(LLBOUND,4.1));
CALL SYMPUT("CILEVEL",PUT(LCILEVEL,4.1));
run;


%IF %UPCASE(&A2CUSP2)=Y %THEN %DO;
data _null_;
set ev2;
CALL SYMPUT("ULOW",PUT(LULOW,4.0));
CALL SYMPUT("UHIGH",PUT(LUHIGH,4.0));
CALL SYMPUT("UINCRE",PUT(LUINCRE,4.0));
CALL SYMPUT("UDIV",PUT(LUDIV,4.0));
CALL SYMPUT("SELOW",PUT(LSELOW,4.0));
CALL SYMPUT("SEHIGH",PUT(LSEHIGH,4.0));
CALL SYMPUT("SEINCRE",PUT(LSEINCRE,4.0));
CALL SYMPUT("SEDIV",PUT(LSEDIV,4.0));
CALL SYMPUT("SMLOW",PUT(LSMLOW,4.0));
CALL SYMPUT("SMHIGH",PUT(LSMHIGH,4.0));
CALL SYMPUT("SMINCRE",PUT(LSMINCRE,4.0));
CALL SYMPUT("SMDIV",PUT(LSMDIV,4.0));
RUN;
%END;
%ELSE %IF %UPCASE(&A2CUSP2)=N %THEN %DO;
data _null_;
CALL SYMPUT("ULOW",PUT(950,4.0));
CALL SYMPUT("UHIGH",PUT(1000,4.0));
CALL SYMPUT("UINCRE",PUT(50,4.0));
CALL SYMPUT("UDIV",PUT(10,4.0));
CALL SYMPUT("SELOW",PUT(22,4.0));
CALL SYMPUT("SEHIGH",PUT(22,4.0));
CALL SYMPUT("SEINCRE",PUT(10,4.0));
CALL SYMPUT("SEDIV",PUT(10,4.0));
CALL SYMPUT("SMLOW",PUT(22,4.0));
CALL SYMPUT("SMHIGH",PUT(22,4.0));
CALL SYMPUT("SMINCRE",PUT(10,4.0));
CALL SYMPUT("SMDIV",PUT(10,4.0));
RUN;
%END;

%IF %UPCASE(&A3CUSP2)=Y %THEN %DO;
data _null_;
set smp2;
CALL SYMPUT("MEAN",PUT(LMEAN,6.3));
CALL SYMPUT("SE",PUT(LSE,6.3));
CALL SYMPUT("SM",PUT(LSM,6.3)); 
run;
%END;
%ELSE %IF %UPCASE(&A3CUSP2)=N %THEN %DO;
data _null_;
CALL SYMPUT("MEAN",PUT(100,6.3));
CALL SYMPUT("SE",PUT(2.2,6.3));
CALL SYMPUT("SM",PUT(2.46,6.3)); 
run;
%END;
%macro cullu;
   LLU = MEAN - Z * SQRT(MVAR / N);
TARGET = &T;
mu=LLU;
n1=10;
n2=30;
k1=2.4;
k2=2.0;
L1=15;
L2=25;
if TARGET LE 101.5 then E =101.5;
else E = TARGET;

z1=(E-mu)*sqrt(n1)/sigma;
z2=(98.5-mu)*sqrt(n1)/sigma;
chi1=probchi((n1-1)*L1**2/(k1*sigma)**2, n1-1);
int1=(probnorm(z1)-probnorm(z2))*chi1;
t=1;
h=0.05;
int2=0;
do x=E to (E+15-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi2=(n1-1)*(E+15-x-h/2)**2/(k1*sigma)**2;
int2=int2+(probnorm(x2)-probnorm(x1))*probchi(chi2, n1-1);
end;

int3=0;
do x=(98.5-15) to (98.5-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi3=(n1-1)*(15-98.5+x+h/2)**2/(k1*sigma)**2;
int3=int3+(probnorm(x2)-probnorm(x1))*probchi(chi3, n1-1);
end;

P1=int1+int2+int3;


zz1=(E-mu)*sqrt(n2)/sigma;
zz2=(98.5-mu)*sqrt(n2)/sigma;
cchi1=probchi((n2-1)*L1**2/(k2*sigma)**2, n2-1);
iint1=(probnorm(zz1)-probnorm(zz2))*cchi1;
iint2=0;
do xx=E to (E+15-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi2=(n2-1)*(E+15-xx-h/2)**2/(k2*sigma)**2;
iint2=iint2+(probnorm(xx2)-probnorm(xx1))*probchi(cchi2, n2-1);
end;

iint3=0;
do xx=(98.5-15) to (98.5-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi3=(n2-1)*(15-98.5+xx+h/2)**2/(k2*sigma)**2;
iint3=iint3+(probnorm(xx2)-probnorm(xx1))*probchi(cchi3, n2-1);
end;

P2a=iint1+iint2+iint3;

zzz1=(123.125-mu)/sigma;
if TARGET LE 101.5 then zzz2=(101.5-24.625-mu)/sigma;
else zzz2 = (TARGET-24.625-mu)/sigma;


P2b=(probnorm(zzz1)-probnorm(zzz2))**30;

P2=max(0, P2a+P2b-1);

overbdl=max(P1, P2);

%MEND cullu;

%MACRO cuulu;
   ULU = MEAN + Z * SQRT(MVAR / N);
TARGET = &T;
mu=ULU;
n1=10;
n2=30;
k1=2.4;
k2=2.0;
L1=15;
L2=25;
if TARGET LE 101.5 then E =101.5;
else E = TARGET;

z1=(E-mu)*sqrt(n1)/sigma;
z2=(98.5-mu)*sqrt(n1)/sigma;
chi1=probchi((n1-1)*L1**2/(k1*sigma)**2, n1-1);
int1=(probnorm(z1)-probnorm(z2))*chi1;
t=1;
h=0.05;
int2=0;
do x=E to (E+15-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi2=(n1-1)*(E+15-x-h/2)**2/(k1*sigma)**2;
int2=int2+(probnorm(x2)-probnorm(x1))*probchi(chi2, n1-1);
end;

int3=0;
do x=(98.5-15) to (98.5-h) by h;
x1=(x-mu)*sqrt(n1)/sigma;
x2=(x+h-mu)*sqrt(n1)/sigma;
chi3=(n1-1)*(15-98.5+x+h/2)**2/(k1*sigma)**2;
int3=int3+(probnorm(x2)-probnorm(x1))*probchi(chi3, n1-1);
end;

P1=int1+int2+int3;


zz1=(E-mu)*sqrt(n2)/sigma;
zz2=(98.5-mu)*sqrt(n2)/sigma;
cchi1=probchi((n2-1)*L1**2/(k2*sigma)**2, n2-1);
iint1=(probnorm(zz1)-probnorm(zz2))*cchi1;
iint2=0;
do xx=E to (E+15-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi2=(n2-1)*(E+15-xx-h/2)**2/(k2*sigma)**2;
iint2=iint2+(probnorm(xx2)-probnorm(xx1))*probchi(cchi2, n2-1);
end;

iint3=0;
do xx=(98.5-15) to (98.5-h) by h;
xx1=(xx-mu)*sqrt(n2)/sigma;
xx2=(xx+h-mu)*sqrt(n2)/sigma;
cchi3=(n2-1)*(15-98.5+xx+h/2)**2/(k2*sigma)**2;
iint3=iint3+(probnorm(xx2)-probnorm(xx1))*probchi(cchi3, n2-1);
end;

P2a=iint1+iint2+iint3;

zzz1=(123.125-mu)/sigma;
if TARGET LE 101.5 then zzz2=(101.5-24.625-mu)/sigma;
else zzz2 = (TARGET-24.625-mu)/sigma;

P2b=(probnorm(zzz1)-probnorm(zzz2))**30;

P2=max(0, P2a+P2b-1);

overbdu=max(P1, P2);

%mend cuulu;

%MACRO CALCUSP2;
DATA TABC;
   D=&D1;
   Z = PROBIT((1 + SQRT(&CILEVEL/100))/2);
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   CALL SYMPUT("TOT",PUT(N, 5.0));
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SEBOUND = 9.2;
   SMLIM = 9.2;
   NEXTL = 84.9;
   NEXTU = 115.1;
  DO SE = D TO SEBOUND BY D;
   MEANL = NEXTL;
   MEANU = NEXTU;
   SMBOUND = SMLIM;
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
  DO SM = D TO SMBOUND BY D;
   IF MEANL = . THEN GOTO OVER;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
   DO MEAN = MEANL - D TO 115.5 BY D;
%cullu
   IF OVERBDL > &LBOUND/100 THEN DO;
      MEANL = MEAN;
      GOTO UPPER;
   END;
 END;
    MEANL = .;
    MEANU = .;
    IF SE=D THEN DO;
     SMLIM = SM - D;
     OUTPUT;
     SM=10;
     GOTO OVER;
                 END;
    IF SM=D THEN DO; SE = 10; GOTO OVER; END;
    GOTO SKIP;
 UPPER:

 DO MEAN = MEANU + D TO 84.9 BY -D;
%cuulu
   IF OVERBDU > &LBOUND/100 THEN DO;
      MEANU = MEAN;
      GOTO OUT;
   END;
 END;
 OUT:
 IF MEANU <= MEANL OR MEAN <= MEANL THEN DO;
    MEANL = .;
    MEANU = .;
    IF SE=D THEN DO;
     SMLIM = SM - D;
     OUTPUT;
     SM=10;
     GOTO OVER;
     END;
    IF SM=D THEN DO; SE = 10; GOTO OVER; END;
 END;

 SKIP: OUTPUT;
    IF SM = D THEN DO;
      NEXTL = MEANL;
      NEXTU = MEANU;
       END;
 OVER:
   END;
  END;
 KEEP N NN L D MEAN SE SM MEANL MEANU OVERBDL OVERBDU;
data tabc;
  set tabc;
  if SE = 10 or SM = 10 then delete;
  run;
PROC SORT DATA=TABC; BY SE SM;run;

%MEND CALCUSP2;

%MACRO PRTCUSP2;
options ls=132;
PROC TRANSPOSE DATA = TABC OUT = LDAT PREFIX = L;
   VAR MEANL;
   BY SE;

PROC TRANSPOSE DATA = TABC OUT = UDAT PREFIX = U;
   VAR MEANU;
   BY SE;

DATA together;
   MERGE LDAT UDAT;
   BY SE;
proc sort data=together; by se;
data miss;
  l1=.; u1=.;
  l2=.; u2=.;
  l3=.; u3=.;
  l4=.; u4=.;
  l5=.; u5=.;
  l6=.; u6=.;
  l7=.; u7=.;
  l8=.; u8=.;
  l9=.; u9=.;
  l10=.; u10=.;
  l11=.; u11=.;
  l12=.; u12=.;
  l13=.; u13=.;
  l14=.; u14=.;
  l15=.; u15=.;
  l16=.; u16=.;
  l17=.; u17=.;
  l18=.; u18=.;
  l19=.; u19=.;
  l20=.; u20=.;
  l21=.; u21=.;
  l22=.; u22=.;
  l23=.; u23=.;
  l24=.; u24=.;
  l25=.; u25=.;
  l26=.; u26=.;
  l27=.; u27=.;
  l28=.; u28=.;
  l29=.; u29=.;
  l30=.; u30=.;
  l31=.; u31=.;
  l32=.; u32=.;
  l33=.; u33=.;
  l34=.; u34=.;
  l35=.; u35=.;
  l36=.; u36=.;
  l37=.; u37=.;
  l38=.; u38=.;
  l39=.; u39=.;
  l40=.; u40=.;
  l41=.; u41=.;
  l42=.; u42=.;
  l43=.; u43=.;
  l44=.; u44=.;
  l45=.; u45=.;
  l46=.; u46=.;
  l47=.; u47=.;
  l48=.; u48=.;
  l49=.; u49=.;
  l50=.; u50=.;
  l51=.; u51=.;
  l52=.; u52=.;
  l53=.; u53=.;
  l54=.; u54=.;
  l55=.; u55=.;
  l56=.; u56=.;
  l57=.; u57=.;
  l58=.; u58=.;
  l59=.; u59=.;
  l60=.; u60=.;
  l61=.; u61=.;
  l62=.; u62=.;
  l63=.; u63=.;
  l64=.; u64=.;
  l65=.; u65=.;
  l66=.; u66=.;
  l67=.; u67=.;
  l68=.; u68=.;
  l69=.; u69=.;
  l70=.; u70=.;
  l71=.; u71=.;
  l72=.; u72=.;
data all;
   merge miss together;
DATA _NULL_;
   SET ALL;
   IF L1 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L1 U1 L2 U2 L3 U3 L4 U4 L5 U5 L6 U6 L7 U7 L8 U8 L9 U9)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '0.1' +10 '0.2' +10 '0.3' +10 '0.4' +10 '0.5' +10
              '0.6' +10 '0.7' +10 '0.8' +10 '0.9' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
TITLE1 "ACCEPTANCE LIMITS FOR CONTENT UNIFORMITY";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "TARGET=&T, LOWER BOUND = &LBOUND, CONFIDENCE LEVEL = &CILEVEL";
TITLE4 'TABLE ENTRIES ARE LOWER(LL) AND UPPER(UL) LIMITS ON THE MEAN';
TITLE5 "OF &TOT ASSAYS-&NUM ASSAYS AT EACH OF &LOC DIFFERENT LOCATIONS";
TITLE6 'SE IS THE POOLED WITHIN LOCATION STANDARD DEVIATION';
TITLE7 'STANDARD DEVIATIONS AND MEANS ARE EXPRESSED IN % CLAIM';
TITLE9 'STANDARD DEVIATION OF LOCATION MEANS';

DATA _NULL_;
   SET ALL;
   IF L10 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L10 U10 L11 U11 L12 U12 L13 U13 L14 U14
      L15 U15 L16 U16 L17 U17 L18 U18)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '1.0' +10 '1.1' +10 '1.2' +10 '1.3' +10 '1.4' +10
              '1.5' +10 '1.6' +10 '1.7' +10 '1.8' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L19 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L19 U19 L20 U20 L21 U21 L22 U22 L23 U23
      L24 U24 L25 U25 L26 U26 L27 U27)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '1.9' +10 '2.0' +10 '2.1' +10 '2.2' +10 '2.3' +10
              '2.4' +10 '2.5' +10 '2.6' +10 '2.7' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L28 = . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L28 U28 L29 U29 L30 U30 L31 U31 L32 U32
      L33 U33 L34 U34 L35 U35 L36 U36)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '2.8' +10 '2.9' +10 '3.0' +10 '3.1' +10 '3.2' +10
              '3.3' +10 '3.4' +10 '3.5' +10 '3.6' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L37 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L37 U37 L38 U38 L39 U39 L40 U40 L41 U41
      L42 U42 L43 U43 L44 U44 L45 U45)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '3.7' +10 '3.8' +10 '3.9' +10 '4.0' +10 '4.1' +10
              '4.2' +10 '4.3' +10 '4.4' +10 '4.5' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L46 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L46 U46 L47 U47 L48 U48 L49 U49 L50 U50
      L51 U51 L52 U52 L53 U53 L54 U54)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '4.6' +10 '4.7' +10 '4.8' +10 '4.9' +10 '5.0' +10
              '5.1' +10 '5.2' +10 '5.3' +10 '5.4' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L55 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L55 U55 L56 U56 L57 U57 L58 U58 L59 U59
      L60 U60 L61 U61 L62 U62 L63 U63)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '5.5' +10 '5.6' +10 '5.7' +10 '5.8' +10 '5.9' +10
              '6.0' +10 '6.1' +10 '6.2' +10 '6.3' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;
DATA _NULL_;
   SET ALL;
   IF L64 EQ . THEN RETURN;
   FILE PRINT HEADER = TOP;
   PUT @1 SE 3.1 +1
     (L64 U64 L65 U65 L66 U66 L67 U67 L68 U68
      L69 U69 L70 U70 L71 U71 L72 U72)
     (5.1 +1 5.1 +2);
   RETURN;
TOP: PUT / @9 '6.4' +10 '6.5' +10 '6.6' +10 '6.7' +10 '6.8' +10
              '6.9' +10 '7.0' +10 '7.1' +10 '7.2' //
           @1  'SE' @7 'LL' @12 'UL' @20 'LL' @25 'UL' @33 'LL'
           @38 'UL' @46 'LL' @51 'UL' @59 'LL' @64 'UL' @72 'LL'
           @77 'UL' @85 'LL' @90 'UL' @98 'LL' @103 'UL'
           @111 'LL' @116 'UL' //;
RETURN;

run;
%MEND PRTCUSP2;


%MACRO EVCUSP2;


%MACRO SIGCUSP2;
%calcusp2
   %DO U = &ULOW %TO &UHIGH %BY &UINCRE;
      %DO SIGSE = &SELOW %TO &SEHIGH %BY &SEINCRE;
         %DO SIGSM = &SMLOW %TO &SMHIGH %BY &SMINCRE;

  DATA SAVE2;
    SET TABC END = LAST;
   U = &U / &UDIV;
   D = &D1;
   SIGSE = &SIGSE / &SEDIV;
   SIGSM = &SIGSM / &SMDIV;
   SIGSM2 = SIGSM * SIGSM;
   EXPSE2 = SIGSE * SIGSE;
   EXPSM2 = EXPSE2 + NN * SIGSM * SIGSM;
   PMEAN = PROBNORM((MEANU - U) * SQRT((N) / EXPSM2))
           - PROBNORM((MEANL - U) * SQRT((N) / EXPSM2));
   PSE = PROBCHI(L * (NN - 1) * SE * SE / EXPSE2, L * (NN -1))
         - PROBCHI(L * (NN - 1) * (SE - D) * (SE - D) /
         EXPSE2, L * (NN - 1));
   PSM = PROBCHI((L - 1) * NN * SM * SM / EXPSM2, L - 1)
         - PROBCHI((L - 1) * NN * (SM - D) * (SM - D) /
         EXPSM2, L - 1);
   P = PMEAN * PSE * PSM;
   PSUM + P;
   IF LAST THEN OUTPUT;
   RUN;
   PROC APPEND BASE = SAVES2E DATA = SAVE2;
   RUN;

       %END;
      %END;
     %END;

%MEND SIGCUSP2;

%SIGCUSP2

PROC PRINT DATA = SAVES2E split = '*';
  label U = 'MEAN'
       SIGSE = 'WITHIN LOCATION*STD DEV'
       SIGSM = 'BETWEEN LOCATION* STD DEV'
       PSUM = 'PROBABILITY*OF*PASSING';
   VAR U SIGSE SIGSM PSUM;
TITLE1 "ACCEPTANCE LIMITS FOR CONTENT UNIFORMITY";
TITLE2 'SAMPLING PLAN 2';
TITLE3 "PROBABILITY OF PASSING ACCEPTANCE LIMIT TABLE";
TITLE4 "WITH &NUM ASSAYS AT EACH OF &LOC LOCATIONS";
TITLE5 "CONFIDENCE LEVEL = &CILEVEL & LOWER BOUND = &LBOUND";
RUN;
%MEND EVCUSP2;

%MACRO SMPCUSP2;

DATA TAB;
   Z = PROBIT((1 + SQRT(&CILEVEL/100))/2);
   NN = &NUM;
   L = &LOC;
   N = NN*L;
   SE = &SE;
   SM = &SM;
   MEAN = &MEAN;
   CILEVEL = &CILEVEL;
   CHIERR = CINV(1 - SQRT(&CILEVEL / 100), L*(NN - 1));
   CHILOC = CINV(1 - SQRT(&CILEVEL / 100),L-1);
   SE2 = SE * SE;
   H2 = L * (NN - 1) / CHIERR - 1;
   SEC = ((1 - 1/NN)*H2*SE2)**2;
   SL2 = SM * SM * NN;
   SL2UB = (L - 1) * SL2 / CHILOC;
   H1 = (L - 1) / CHILOC - 1;
   FIRST = ((1 / NN)*H1*SL2)**2;
      PTEST = (1 / NN) * SL2 + (1 - 1/NN) * SE2;
      VAR = PTEST + SQRT(FIRST + SEC);
      MVAR = SL2UB;
   SIGMA = SQRT(VAR);
%cullu
%cuulu
  OVERBD = MIN(OVERBDU, OVERBDL);
 KEEP SE MEAN SM OVERBD;
PROC PRINT SPLIT='*';
 LABEL   SE = 'SAMPLE*WITHIN LOCATION*STD DEV'
         MEAN = 'SAMPLE*MEAN'
         SM = 'SAMPLE*BETWEEN LOCATION*STD DEV'
         OVERBD = 'LOWER BOUND';
  ID MEAN;
  VAR SE SM OVERBD;
TITLE1 "ACCEPTANCE LIMITS FOR CONTENT UNIFORMITY";
TITLE2 "SAMPLING PLAN 2 (&LOC LOCATIONS, &NUM PER LOCATION)";
TITLE3 "PROPORTION OF FUTURE SAMPLES PASSING THE USP TEST";
TITLE4 "WITH &CILEVEL.% ASSURANCE";
TITLE5 'FOR GIVEN SAMPLE MEAN, WITHIN AND BETWEEN LOCATION STD DEV';
RUN;
%MEND SMPCUSP2;

%MACRO ANACUSP2;
    
%IF %UPCASE(&A1CUSP2)=Y %THEN %DO;
     %CALCUSP2;
     %PRTCUSP2;
    %END;
%IF %UPCASE(&A2CUSP2)=Y %THEN %DO;
      %EVCUSP2;
PROC DATASETS LIBRARY=WORK;
   DELETE SAVES2E;
    %END;
%IF %UPCASE(&A3CUSP2)=Y %THEN %DO;
     %SMPCUSP2;
    %END;
%MEND ANACUSP2;

%ANACUSP2

RUN;
%MEND CUSP2;
%CUSP2
